﻿--[[
--                                           MOUNTY ©2009 through 2013 or (c)2009 through 2013
--                                                         by William B. Steele
--                                              [ Draewind <> Silver Hand US <> Alliance ]
--                                                         WOWUI@CompuBall.com
--   
--		This program is free software: you can redistribute it and/or modifyit under the terms of the GNU General Public License as published by
--		the Free Software Foundation, either version 3 of the License, or(at your option) any later version.
		
--		This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
--		MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more details.

--		You should have received a copy of the GNU General Public License along with this program.  If not, see <http://www.gnu.org/licenses/>
--]]
--[[
--]]
--------------------------------------------------------------------------------------------------------------------------------
-- Global Variables
--------------------------------------------------------------------------------------------------------------------------------
local Ability = {};
Ability["Ride"] = false;
Ability["Fly"] = false;
Ability["Vashj"] = false;

Ability["Location"] = {
	["Pandaria"] = false;
	["Northrend"] = false;
	["Outland"] = false;
	["Kalimdor"] = false;
	["Eastern"] = false;
	["Maelstrom"] = false;
};
Ability["Skill"] = {
	["Apprentice"] = false;
	["Journeyman"] = false;
	["Expert"] = false;
	["Artisan"] = false;
	["Master"] = false;
	["Journeyman"] = false;
	["Cold"] = false;
	["License"] = false;
	["WFW"] = false;
	["Serpent"] = false;
	["MountUp"] = false;
};
Ability["Mount"] = {
	["mounts"] = 0;
	["active"] = 0;
	["name"] = {
		["ride"] = "None Set";
		["shiftride"] = "None Set";
		["fly"] = "None Set";
		["shiftfly"] = "None Set";
		["serpent"] = "None Set";
		["shiftserpent"] = "None Set";
		["cloud"] = "None Set"; -- if used when cloud serpent riding is available
		["shiftcloud"] = "None Set"; -- if used when cloud serpent riding is available
	};
};

local Continent = "Unknown";

local Vashj = {
	["name"] = "Unknown";
	["coord"] = 0;
};

local Mount = {};

local Flyable = false;

local State = {
	["IsMounted"] = false;
	["IsFlying"] = false;
}

local Macro = {
	["SAVE"] = 1;
	["MAXGEN"] = 36;
	["MAXCHAR"] = 18;
	["FIRSTGEN"] = 1;
	["FIRSTCHAR"] = 16777217;
	["LASTGEN"] = 18;
	["LASTCHAR"] = 16777234;
	["NAME"] = "          ";
	["iconTexture"] = "Interface\\Icons\\INV_Misc_QuestionMark";

	["Index"] = 0;
	["ID"] = 0;
	["perChar"] = false;
	["GENSPACE"] = false;
	["CHARSPACE"] = false;
	["iconNum"] = 1;
	["noflyzone"] = false;
	["rewrite"] = true;
	["safeflytxt"] = MOUNTY_SAFEFLY;
	["flyable"] = false;
	["combatflag"] = false;
	["Using"] = false;
	["Writing"] = false;
};

local Button = {
	[1] = "LeftButton";
	[2] = "RightButton";
	[3] = "MiddleButton";
	[4] = "Button4";
	[5] = "Button5";
	["LeftButton"] = 1;
	["RightButton"] = 2;
	["MiddleButton"] = 3;
	["Button4"] = 4;
	["Button5"] = 5;
	["Modifier"] = "nomod";
	["modNim"] = 0;
	["nomod"] = true;
	["Shift"] = false;
	["Ctrl"] = false;
	["Alt"] = false;
}

local Wintergrasp = {
	["Flag"] = false;
	["Timer"] = true;
}

local FirstUse = true;
local CheckEnabled = true;
local isSwimmingFlag = false;
--------------------------------------------------------------------------------------------------------------------------------
-- Initialization
--------------------------------------------------------------------------------------------------------------------------------
function Mounty_InitializeVar()
	Mounty["Player"] = UnitName("player");
	Mounty["Faction"] = UnitFactionGroup("player");
--DEFAULT_CHAT_FRAME:AddMessage("|cff00ffffMounty Faction"..Mounty["Faction"].."|r");
	Mounty["Realm"] = GetRealmName();
	Mounty["RealmID"] = string.gsub(Mounty["Realm"], " ", "")
	Mounty["ID"] = Mounty["Player"].."@"..Mounty["Faction"].."@"..Mounty["RealmID"];
end

function Mounty_SetAll()
	if CheckEnabled then
		Mounty_InitializeVar();
		Mounty_GetMountList();
		Mounty_VashjCheck();
		Mounty_SetFlyable();
	end
	if Mounty_SetEnable()then
		Mounty_ResetVersion();
		Mounty_GetMountList();
		Mounty_VashjCheck();
		Mounty_SetFlyable();
		Mounty_WriteMacro(true);		
	end
end

function Mounty_ResetVersion(forcereset)
	local reset = false;
	if forcereset then
		reset = true;
	end
	if not Mounty.Version then
		Mounty["Version"] = "0.0.0.0.0";
	end
	if not (MOUNTY_VERSION == Mounty.Version) then
		DEFAULT_CHAT_FRAME:AddMessage("|cffff0000Mounty Version Conflict.|r");
		DEFAULT_CHAT_FRAME:AddMessage("|cff00ffffMounty v"..MOUNTY_VERSION.."|r");
		reset = true;
	end
	local fly, shiftfly, ride, shiftride = "None Set", "None Set", "None Set", "None Set";
	local pchar = Mounty.perChar;
	local safe = Mounty.SafeFly;
	local enabled = Mounty.Enabled;
---- Add conversion blocks here: (Gather current settings)
---- Block #01 v3.3.5.1.0 - 4.0.1.1.0
	if Mounty.Ride.Text then
		reset = true;
		DEFAULT_CHAT_FRAME:AddMessage("|cffff0000 Resetting OLD Ride Mount|r");
		ride = Mounty.Ride.Text;
	end
	if Mounty.Fly.Text then
		reset = true;
		DEFAULT_CHAT_FRAME:AddMessage("|cffff0000 Resetting OLD Fly Mount|r");
		fly = Mounty.Fly.Text;
	end
---- Block #02 v4.0.1.1.0 - v4.0.1.1.1
	if Mounty.Ride.nomod then
		ride = Mounty.Ride.nomod.name;
	else
		DEFAULT_CHAT_FRAME:AddMessage("|cffff0000 Resetting Ride Mount|r");
		reset = true;
	end
	if Mounty.Fly.nomod then
		fly = Mounty.Fly.nomod.name;
	else
		DEFAULT_CHAT_FRAME:AddMessage("|cffff0000 Resetting Fly Mount|r");
		reset = true;
	end
	if Mounty.Ride.Shift then
		shiftride = Mounty.Ride.Shift.name;
	else
		reset = true;
		DEFAULT_CHAT_FRAME:AddMessage("|cffff0000 Resetting Shift Ride Mount|r");
		shiftride = ride;
	end
	if Mounty.Fly.Shift then
		shiftfly = Mounty.Fly.Shift.name;
	else
		reset = true;
		DEFAULT_CHAT_FRAME:AddMessage("|cffff0000 Resetting Fly Mount|r");
		shiftfly = fly;
	end
---- END BLOCKS
	if reset then
		Mounty_Reset();
---- Recover previous settings
		Mounty.Fly.nomod.name = fly;
		Mounty.Ride.nomod.name = ride;
		Mounty.Fly.Shift.name = shiftfly;
		Mounty.Ride.Shift.name = shiftride;
		Mounty.perChar = pchar;
		Mounty.SafeFly = safe;
		Mounty.Enabled = enabled;
		Mounty_GetMountList();
	end
end

function Mounty_Reset()
	DEFAULT_CHAT_FRAME:AddMessage("|cff00ff00Mounty has reset:");
	if not Mounty.Version then
		Mounty["Version"] = "0.0.0.0.0";
	else
		DEFAULT_CHAT_FRAME:AddMessage("|cffff0000"..Mounty.Version.."|r");
	end
	Mounty = nil;
	Mounty ={};
	Mounty["Name"] = MOUNTY_NAME;
	Mounty["Version"] = MOUNTY_VERSION;
	Mounty["FileNumber"] = MOUNTY_FILENUM;
	Mounty_InitializeVar()
	Mounty["SelectEnable"] = true;
	Mounty["Enabled"] = false;
	Mounty["SafeFly"] = true;
	Mounty["perChar"] = false;
	Mounty["Fly"] = {}
	Mounty.Fly["nomod"] = {};
	Mounty.Fly.nomod["name"] = "None Set";
	Mounty.Fly.nomod["coord"] = 0;
	Mounty["Ride"] = {}
	Mounty.Ride["nomod"] = {};
	Mounty.Ride.nomod["name"] = "None Set";
	Mounty.Ride.nomod["coord"] = 0;
	Mounty.Ride["Shift"] = {};
	Mounty.Ride.Shift["name"] = "None Set";
	Mounty.Ride.Shift["coord"] = 0;
	Mounty.Fly["Shift"] = {};
	Mounty.Fly.Shift["name"] = "None Set";
	Mounty.Fly.Shift["coord"] = 0;
	DEFAULT_CHAT_FRAME:AddMessage("|cff00ff00"..Mounty.Version.."|r");
end

function Mounty_Use()
	local button = Mounty_GetMacroButton();
	if FirstUse then
		Mounty_SetAll();
		FirstUse = false;
	end
	if(Macro.Writing == false) then
		Macro.Using = true;
		Mounty_SetStateVariables();
		if(State.IsMounted) then
			Mounty_VehicleExit();
		else
			local fly = Mounty_SetFlyable();
			local flyid = Mounty.Fly[Button.Modifier].coord;
			local rideid = Mounty.Ride[Button.Modifier].coord;
			local flyname = Mounty.Fly[Button.Modifier].name;
			local ridename = Mounty.Ride[Button.Modifier].name;
-- Vashj'ir segment -------------------------------------------------
			if MOUNTY_VASHJ_FLAG then
				local modifier = Button.Modifier;
				fly = true; --- for the nonflyable returns that occur
				if Ability.Vashj and IsSwimming() then
					if modifier == "nomod" then
						flyid = Vashj.coord;
						flyname = Vashj.name;
					end				
					if modifier == "Shift" then
						flyid = Mounty.Fly.nomod.coord;
						flyname = Mounty.Fly.nomod.name;
						if not Ability.Fly then
							flyid = Vashj.coord;
							flyname = Vashj.name;
						end
					end
				else
					if modifier == "nomod" then
						flyid = Mounty.Ride[modifier].coord;
						flyname = Mounty.Ride[modifier].name;
					end				
					if modifier == "Shift" then
						flyid = Mounty.Fly.nomod.coord;
						flyname = Mounty.Fly.nomod.name;
						if not Ability.Fly then
							flyid = Mounty.Ride[modifier].coord;
							flyname = Mounty.Ride[modifier].name;
						end
					end
				end				
			end
---------------------------------------------------------------------
			if(button == 2) then
				fly = false;
			end
			if fly then
				CallCompanion("MOUNT", flyid)
			else
				CallCompanion("MOUNT", rideid)
			end
		end
		Macro.Using = false;
	end
end

function Mounty_VehicleExit()
	local dismount = false;
	if not Mounty.SafeFly then
		dismount = true;
	end
	if IsFlying() then
		State.IsFlying = true;
	else
		dismount = true;
	end
	local buttonNumber = Mounty_GetMacroButton();
	if(buttonNumber == 2) then
		dismount = true;
	end

	if dismount then
		local test = CanExitVehicle();
		if (test == 1) then
			VehicleExit();
		else
			DismissCompanion("MOUNT");
		end
	end
end

function Mounty_GetMacroButton()
	local buttonNumber = 0;
	local buttonString = "None";
--	local macroIndex = GetRunningMacro();
	buttonString = GetRunningMacroButton();
	buttonNumber = Button[buttonString];
	Mounty_GetModifierKey();
	if Button.Alt then
		buttonNumber = 2;
	end
	return buttonNumber, buttonString;
end

function Mounty_GetModifierKey()
	local rt = {};
	Button.Modifier = "nomod";
	Button.modNum = 0;
	Button.nomod = true;
	Button.Shift = false;
	Button.Ctrl = false;
	Button.Alt = false;
	
	if(IsModifierKeyDown() == 1) then
		Button.nomod = false;
		if(IsAltKeyDown() == 1) then
			Button.modNum = Button.modNum + 3;
			Button.Modifier = "Alt";
			Button[Button.Modifier] = true;
		end
		if(IsControlKeyDown() == 1) then
			Button.modNum = Button.modNum + 20;
			Button.Modifier = "Ctrl";
			Button[Button.Modifier] = true;
		end
		if(IsShiftKeyDown() == 1) then
			Button.modNum = Button.modNum + 100;
			Button.Modifier = "Shift";
			Button[Button.Modifier] = true;
		end
		if Button.Modifier == "Ctrl" or Button.Modifier == "Alt" then
			Button.Modifier = "nomod";
		end
	end
--	Button.modNum:
--	100	= shift
--	20	= ctrl
--	3	= alt
--	120	= shift+ctrl
--	103	= shift+alt
end

--------------------------------------------------------------------------------------------------------------------------------
-- Initial Support and Slash Command
--------------------------------------------------------------------------------------------------------------------------------
function Mounty_SetEnable()
	Mounty.Enabled = false;
	if Ability.Ride and (Ability.Mount.name.ride ~= "None Set") then
		Mounty.Enabled = Mounty.SelectEnable;
	end
	local test = Mounty_FindMacro();
	if Mounty.Enabled then
		if test < 0 then
		 	PlaySoundFile(MOUNTY_ErrorSound);
	  		DEFAULT_CHAT_FRAME:AddMessage("|cffff0000---------------------------------|r");
	  		DEFAULT_CHAT_FRAME:AddMessage("|cffff0000NO SPACE to create <Mounty MACRO>|r");
	  		DEFAULT_CHAT_FRAME:AddMessage("|cffff0000---------------------------------|r");
		end
	end
	return Mounty.Enabled;
end

function Mounty_Enable()
	if Mounty_CombatCheck() then
		if not Mounty.SelectEnable then
			Mounty.SelectEnable = true;
			Mounty_SetAll();
 			Mounty_PrintSettings(true);
		else
		 	PlaySoundFile(MOUNTY_ErrorSound);
	  		DEFAULT_CHAT_FRAME:AddMessage("|cffff0000<Mounty> is already selcted to Enabled.|r");
		end
	else  
  		DEFAULT_CHAT_FRAME:AddMessage("|cffff0000<Mounty> Action not permitted during combat.|r");
	end
	Mounty_WriteMacro();		
end

function Mounty_Disable()
	if Mounty_CombatCheck() then
		if Mounty.Enabled then
			Mounty_DeleteMacro();
			Mounty.SelectEnable = false;
			Mounty.Enabled = false;
			Mounty_SetAll();
 			Mounty_PrintSettings(true);
		else
		 	PlaySoundFile(MOUNTY_ErrorSound);
	  		DEFAULT_CHAT_FRAME:AddMessage("|cffff0000<Mounty> is already selcted to Disabled.|r");
		end
	else  
  		DEFAULT_CHAT_FRAME:AddMessage("|cffff0000<Mounty> Action not permitted during combat.|r");
	end  
end

function Mounty_perCharToggle()
	Mounty_DeleteMacro();
	local entry = Mounty.perChar;
	Mounty_GetMacroSpace();
	if(Mounty.perChar) then
		if(Macro.GENSPACE) then
			Mounty.perChar = false;
		end
	else
		if(Macro.CHARSPACE) then
			Mounty.perChar = true;
		end
	end
	if(entry == Mounty.perChar) then
	 	PlaySoundFile(MOUNTY_ErrorSound);
  		DEFAULT_CHAT_FRAME:AddMessage("|cffff0000--------------------------|r");
  		DEFAULT_CHAT_FRAME:AddMessage("|cffff0000UNABLE to move MACRO!! -- No Space|r");
  		DEFAULT_CHAT_FRAME:AddMessage("|cffff0000--------------------------|r");
	elseif (Mounty.perChar) then
	 	PlaySoundFile(MOUNTY_ActionSound);
 		DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff-----------------------------------|r");
  		DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff<Mounty Macro> is now in the|r|cff00ff00 Character Specific Tab.|r");
  		DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff-----------------------------------|r");
  	else
	 	PlaySoundFile(MOUNTY_ActionSound);
		DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff-----------------------------------|r");
  		DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff<Mounty Macro> is now in the|r|cff00ff00 General Tab.|r");
  		DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff-----------------------------------|r");
   	end
	Mounty_WriteMacro();		
end

function Mounty_SafeFlyToggle()
		if Mounty.SafeFly then
			Mounty.SafeFly = false;
			Macro.safeflytxt = " ";
		   	DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff<Mounty SafeFly>|r is|cffff0000 Off|r");
		else
			Mounty.SafeFly = true;
			Macro.safeflytxt = MOUNTY_SAFEFLY;
		   	DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff<Mounty SafeFly>|r is|cff00ff00 On|r");
		end
end

function Mounty_SetFlyable()
	local fly = false;
	if Ability.Fly and (Ability.Mount.name.fly  ~= "None Set") then
		Flyable = Ability.Location[Continent];
		if Flyable then
			Flyable = Mounty_WintergraspCheck();
		end
	end
	Macro.flyable = Flyable;
	if IsFlyableArea() or Wintergrasp.Flag then
		fly = Flyable;
	end
	Flyable = fly;
	return fly;
end

function Mounty_GetContinentName()
	SetMapToCurrentZone();
	local contNum = GetCurrentMapContinent();
	local continent = "Unkown";
	if(contNum > 0) then
		continent = select(contNum, GetMapContinents());
--DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff<Mounty> Continent Name = "..continent.."|r");
--DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff<Mounty> Continent Number = "..contNum.."|r");
	end
	Continent = Mounty_ConvertZoneName(continent);
	MOUNTY_ZONE = continent;
	return continent;
end

function Mounty_ConvertZoneName(zone)
	if (zone == "Eastern Kingdoms") then
		zone = "Eastern";
	end
	if (zone == "The Maelstrom") then
		zone = "Maelstrom";
	end
	return zone;
end

function Mounty_VashjCheck()
	local returnvalue = false;
	local old = MOUNTY_VASHJ_FLAG;
	MOUNTY_VASHJ_FLAG = false;
	local continent = Mounty_GetContinentName();
	if (continent == "Eastern Kingdoms") then
		local continentid = GetCurrentMapContinent();
		local zones = {GetMapZones(continentid)};
		MOUNTY_ZONE = zones[GetCurrentMapZone()]
		if (MOUNTY_ZONE == "Abyssal Depths") then
			MOUNTY_ZONE = MOUNTY_VASHJ_TEXT;
		elseif (MOUNTY_ZONE == "Kelp'thar Forest") then
			MOUNTY_ZONE = MOUNTY_VASHJ_TEXT;
		elseif (MOUNTY_ZONE == "Shimmering Expanse") then
			MOUNTY_ZONE = MOUNTY_VASHJ_TEXT;
		elseif (MOUNTY_ZONE == "Vashj'ir") then
			MOUNTY_ZONE = MOUNTY_VASHJ_TEXT;
		end
		if (MOUNTY_VASHJ_TEXT == MOUNTY_ZONE) then
			MOUNTY_VASHJ_FLAG = true;
		else
			MOUNTY_VASHJ_FLAG = false;
		end
	end
	if old then
		if not MOUNTY_VASHJ_FLAG then
			returnvalue = true;
		end
	else
		if MOUNTY_VASHJ_FLAG then
			returnvalue = true;
		end
	end
	return returnvalue;
end

function Mounty_Wintergrasp()
	local timer = false;
	if (Mounty_GetWintergraspWaitTime()>0) then
		timer = true;
	end
	timer = true;
	Wintergrasp.Flag = false;
	Wintergrasp.Timer = true;
	if ("Wintergrasp" == GetRealZoneText()) then
		Wintergrasp.Flag = true;
		Wintergrasp.Timer = timer;
	end
	return timer;
end

function Mounty_GetWintergraspWaitTime()
	local WintergraspTimer = 0;
	local pvpID, localizedName, isActive, canQueue, startTime, canEnter = GetWorldPVPAreaInfo(1)
	local ii = GetNumWorldPVPAreas();
	for i=1,ii do
		pvpID, localizedName, isActive, canQueue, startTime, canEnter = GetWorldPVPAreaInfo(i)
		if localizedName == "Wintergrasp" then
			if isActive then
				WintergraspTimer = 0;
			else
				WintergraspTimer = startTime;
			end
		end
	end
	return WintergraspTimer;
end

function Mounty_WintergraspCheck()
	Mounty_Wintergrasp();
	local timer = Wintergrasp.Timer;
	return timer;
end

function Mounty_SetStateVariables()
	State.IsMounted = false;
	State.IsFlying = false;
	local vehicle = false;
	local taxi = UnitOnTaxi("player");
	if taxi ~= 1 then
		if CanExitVehicle() then
			vehicle = true;
		end
		if IsMounted() or vehicle then
			State.IsMounted = true;
		end
		if IsFlying() then
			State.IsFlying = true;
		end
	end
	return vehicle;
end

function Mounty_CombatCheck()
	local combatcheck = true;
	if InCombatLockdown() then
		combatcheck = nil;
	end
	return combatcheck;
end

function Mounty_ExitCombat()
	if (Macro.combatflag == true) then
		Macro.combatflag = false;
		Mounty_WriteMacro();		
	end
end

function Mounty_AuraCheck()
	local swimming = IsSwimming();
	if swimming then
		if not MOUNTY_SWIMFLAG then
			Mounty_WriteMacro();
		end
		MOUNTY_SWIMFLAG = true;
	else
		if MOUNTY_SWIMFLAG then
			Mounty_WriteMacro();
		end
		MOUNTY_SWIMFLAG = false;
	end
end
--------------------------------------------------------------------------------------------------------------------------------
-- Macro
--------------------------------------------------------------------------------------------------------------------------------
function Mounty_WriteMacro()
	if Mounty_CombatCheck() then
		if not Macro.Using then
			Macro.Writing = true;
			local macroID;
			local macroIndex = Mounty_FindMacro();
			if macroIndex == 0 then
				local iconNum, serv, perChar, eperChar = Mounty_SetMacroValues();
				local body = Mounty_SetMacroBody();
				macroID = CreateMacro(Macro.NAME, iconNum, body, perChar, serv);
				Macro.Index = Mounty_FindMacro();
			elseif macroIndex > 0 then
				local iconNum, serv, perChar, eperChar = Mounty_SetMacroValues();
				local body = Mounty_SetMacroBody();
				macroID = EditMacro(macroIndex, Macro.NAME, iconNum, body, serv, eperChar);
				Macro.Index = macroIndex;
			elseif macroIndex < 0 then
			 	PlaySoundFile(MOUNTY_ErrorSound);
		  		DEFAULT_CHAT_FRAME:AddMessage("|cffff0000---------------------------------|r");
		  		DEFAULT_CHAT_FRAME:AddMessage("|cffff0000NO SPACE to create <Mounty MACRO>|r");
		  		DEFAULT_CHAT_FRAME:AddMessage("|cffff0000---------------------------------|r");
		  		Macro.Index = 0;
		   		Mounty_Disable();
			end
			Macro.Writing = false;
		end
	else
		Macro.combatflag = true;
	end
end

function Mounty_SetMacroBody()
	Mounty_GetMountList();
	Mounty_SetFlyable();
	local textline = {
		[1] ="";
		[2] ="";
	};
	local flyable = ",flyable\]";
	if Wintergrasp.Flag then
		flyable = "\]";
	end
	
	local flynomod = Mounty.Fly.nomod.name;
	local flyshift = Mounty.Fly.Shift.name;
	local ridenomod = Mounty.Ride.nomod.name;
	local rideshift = Mounty.Ride.Shift.name;
-- Vashj'ir segment -------------------------------------------------
	if MOUNTY_VASHJ_FLAG then
		if Ability.Vashj and IsSwimming() then
			Macro.flyable = true;
			flyable = "\]";
			flynomod = Vashj.name;
			flyshift = Mounty.Fly.nomod.name;
			if not Ability.Fly then
				flyshift = Vashj.name;
			end
		else
			Macro.flyable = true;
			flyable = "\]";
			flynomod = Mounty.Ride.nomod.name;
			flyshift = Mounty.Fly.nomod.name;
			if not Ability.Fly then
				flyshift = Mounty.Ride.nomod.name;
			end
		end
	end
----------------------------------------------------------------------
--	Line 1
	if(Macro.flyable) then
		textline[1] = "#showtooltip \[nomod:alt,mod:shift"..flyable..flyshift..";\[nomod:alt"..flyable..flynomod..";\[mod:shift\]"..rideshift..";"..ridenomod.."\n";
--		textline[1] = "#showtooltip \[mod:alt,mod:shift\]"..rideshift..";\[nomod:alt,mod:shift"..flyable..flyshift..";\[nomod:alt"..flyable..flynomod..";\[mod:alt\]"..ridenomod..";"..ridenomod.."\n";
	else
		textline[1] = "#showtooltip \[mod:shift\]"..rideshift..";"..ridenomod.."\n";
	end
	
--	Line 2
	textline[2] = "/run Mounty_Use()\n";

	body = textline[1]..textline[2];
	return body;
end

function Mounty_SetMacroValues()
	local iconTexture = Macro.iconTexture;
	local iconNum = "INV_Misc_QuestionMark" -- iconNum = Macro.iconNum;
	local perChar = nil;
	local eperChar = 0;
	local serv = Macro.SAVE;
	if(Mounty.perChar) then
		perChar = 1;
		eperChar = 1;
	end
	Macro.perChar = Mounty.perChar;
	return iconNum, serv, perChar, eperChar;
end

function Mounty_FindMacro()
	local space = Mounty_GetMacroSpace();
	local index = GetMacroIndexByName(Macro.NAME);
	local returnindex = index;
	if(index == 0) then
		if(Mounty.perChar) then
			if not Macro.CHARSPACE then
				returnindex = returnindex - 1;
			end
		else
			if not Macro.GENSPACE then
				returnindex = returnindex - 1;
			end
		end
	end
	if returnindex < 0 then
		if space then
			Mounty_perCharToggle();
			returnindex = 0;
		end
	end
	return returnindex;
end

function Mounty_GetMacroSpace()
	local space = false;
	local numgen,numperchar = GetNumMacros();
	if(numgen < Macro.MAXGEN) then
		Macro.GENSPACE = true;
		space = true;
	end
	if(numperchar < Macro.MAXCHAR) then
		Macro.CHARSPACE = true;
		space = true;
	end
	return space;
end

function Mounty_DeleteMacro()
	local index = Mounty_FindMacro();
	if(index>0) then
		DeleteMacro(index);
	end
end

--------------------------------------------------------------------------------------------------------------------------------
-- Mounts
--------------------------------------------------------------------------------------------------------------------------------
function Mounty_GetMountList()
	Mounty_GetRidingSkill();
	if Ability.Ride then
		Mount = nil;
		Mount = {};
		Ability.Mount.active = 0;
		Vashj.name = "Unknown"
		Vashj.coord = 0;
		Ability.Vashj = false;
		Mounty_SetDefMountList();
		Mounty_CheckDefaultMount();
		local i, ii = 1, GetNumCompanions("MOUNT");
		Ability.Mount.mounts = ii;
		if(ii > 0) then
			for i=1,ii do
				local ID, ctn, spellID, icon, issummoned = GetCompanionInfo("MOUNT", i);
				local level, n = Mounty_AddMountList(ctn, spellID);
--DEFAULT_CHAT_FRAME:AddMessage("|cffff0000"..n.." = "..level.."|r");
				-- 1 = riding
				-- 2 = flying
				-- 3 = riding/flying (ride and fly)
				-- 4 = cloud serpent
				-- 5 = seahorse swim mount in Vashj'r		
				Mount[i] = n;
	
				if Mount[n] then Mount[n] = nil; end
				Mount[n] = {};
				Mount[n]["ctname"] = ctn;
				Mount[n]["spellID"] = spellID;
				Mount[n]["icon"] = icon;
				Mount[n]["level"] = level;
				if issummoned then Ability.Mount.active = i; end
				if level == 5 then
					Ability.Vashj = true;
					Vashj.name = n;
					Vashj.coord = i;
				else
					if n == Mounty.Ride.nomod.name then
						Mounty.Ride.nomod.coord = i;
						if (level == 1) or (level == 3) then
							Ability.Mount.name.ride = n;
						end
					end
					if n == Mounty.Ride.Shift.name then
						Mounty.Ride.Shift.coord = i;
						if (level == 1) or (level == 3) then
							Ability.Mount.name.shiftride = n;
						end
					end
					if n == Mounty.Fly.nomod.name then
						Mounty.Fly.nomod.coord = i;
						if (level == 2) or (level == 3) then
							Ability.Mount.name.fly = n;
							Ability.Mount.name.cloud = "None Set";
						end
						if (level == 4) then
							Ability.Mount.name.serpent = n;
							Ability.Mount.name.cloud = n;
						end
					end
					if n == Mounty.Fly.Shift.name then
						Mounty.Fly.Shift.coord = i;
						if (level == 2) or (level == 3) then
							Ability.Mount.name.shiftfly = n;
							Ability.Mount.name.shiftcloud = "None Set";
						end
						if (level == 4) then
							Ability.Mount.name.shiftserpent = n;
							Ability.Mount.name.shiftcloud = n;
						end
					end
				end
			end
		end
	end
end

function Mounty_SetDefMountList()
	local i, ii = 1, 0;
	Ability.Mount.name = MOUNTY[Mounty.Faction];
	i, ii = 1, GetNumCompanions("MOUNT");
	Ability.Mount.mounts = ii;
	if(ii > 0) then
		for i=1,ii do
			local ID, ctn, spellID, icon, issummoned = GetCompanionInfo("MOUNT", i);
			local level, n = Mounty_AddMountList(ctn, spellID);
			-- 1 = riding
			-- 2 = flying
			-- 3 = riding/flying (ride and fly)
			-- 4 = cloud serpent
			-- 5 = seahorse swim mount in Vashj'r		
			if level < 5 then
				if (level == 1) or (level == 3) then
					if Ability.Mount.name.ride == "None Set" then Ability.Mount.name.ride = n; end
					if Ability.Mount.name.shiftride == "None Set" then Ability.Mount.name.shiftride = n; end
				end
				if (level == 2) or (level == 3) then
					if Ability.Mount.name.fly == "None Set"  then Ability.Mount.name.fly = n; end
					if Ability.Mount.name.shiftfly == "None Set" then Ability.Mount.name.shiftfly = n; end
				end
				if (level == 4) then
					if Ability.Mount.name.serpent == "None Set"  then Ability.Mount.name.serpent = n; end
					if Ability.Mount.name.shiftserpent == "None Set"  then Ability.Mount.name.shiftserpent = n; end
				end
			end
		end
	end
	MOUNTY[Mounty.Faction] = Ability.Mount.name;
	return i, ii;
end

function Mounty_SetMount(flyorride)
	Mounty_GetModifierKey();
	Mounty_GetMountList();
	local name, level, coord = "Not Mounted", 0, 0;
	local active = Ability.Mount.active;
	if active == 0 then
	 	PlaySoundFile(MOUNTY_ErrorSound);
  		DEFAULT_CHAT_FRAME:AddMessage("|cffff0000Mount is not Set|r");
   		DEFAULT_CHAT_FRAME:AddMessage("|cffff0000"..Mounty.Player.." must be mounted to Set a mount.|r");
   	else
   		name = Mount[active];
   		level = Mount[name].level;
   		coord = Mount[name].coord;
   		if level == 5 then
		 	PlaySoundFile(MOUNTY_ErrorSound);
	  		DEFAULT_CHAT_FRAME:AddMessage("|cffff0000Mount is not Set|r");
	  		DEFAULT_CHAT_FRAME:AddMessage("|cffff0000The Vashj'ir mount may not be set.|r");
	   		DEFAULT_CHAT_FRAME:AddMessage("|cffff0000The Vashj'ir mount is handled automatically.|r");
   		else
			if not flyorride then
			 	PlaySoundFile(MOUNTY_ErrorSound);
		  		DEFAULT_CHAT_FRAME:AddMessage("|cffff0000Mount is not Set|r");
		  		DEFAULT_CHAT_FRAME:AddMessage("|cffff0000Unable to determine if setting flying mount or riding mount.|r");
		   		DEFAULT_CHAT_FRAME:AddMessage("|cffff0000You must type /mty fly -or- /mty ride|r");
		   	else
		   		if flyorride == "ride" then
		   			Mounty.Ride[Button.Modifier].name = name;
		   			Mounty.Ride[Button.Modifier].coord = active;
		 			Mounty_PrintSettings(true);
		   		elseif flyorride == "fly" then
		   			Mounty.Fly[Button.Modifier].name = name;
		   			Mounty.Fly[Button.Modifier].coord = active;
					Mounty_PrintSettings(true);
		   		else
				 	PlaySoundFile(MOUNTY_ErrorSound);
			  		DEFAULT_CHAT_FRAME:AddMessage("|cffff0000Mount is not Set|r");
			  		DEFAULT_CHAT_FRAME:AddMessage("|cffff0000Unable to determine if setting flying mount or riding mount.|r");
			   		DEFAULT_CHAT_FRAME:AddMessage("|cffff0000You must type /mty fly -or- /mty ride|r");
		   		end
	   		end
   		end
		Mounty_WriteMacro();		
	end
end

function Mounty_CheckDefaultMount()
	if Mounty.Ride.nomod.name == "None Set" then
		Mounty.Ride.nomod.name = Ability.Mount.name.ride;
	end
	if Mounty.Ride.Shift.name == "None Set" and Ability.Mount.name.shiftride ~= "None Set" then
		Mounty.Ride.Shift.name = Ability.Mount.name.shiftride;
	end
	if Mounty.Fly.nomod.name == "None Set" then
		Mounty.Fly.nomod.name = Ability.Mount.name.fly;
		if Ability.Skill.Serpent and (Ability.Mount.name.cloud ~= "None Set") then
			Mounty.Fly.nomod.name = Ability.Mount.name.serpent;
		end
	end
	if Mounty.Fly.Shift.name == "None Set" then
		Mounty.Fly.Shift.name = Ability.Mount.name.shiftfly;
		if Ability.Skill.Serpent and (Ability.Mount.name.shiftcloud ~= "None Set") then
			Mounty.Fly.Shift.name = Ability.Mount.name.shiftserpent;
		end
	end
end

--------------------------------------------------------------------------------------------------------------------------------
-- Imported and converted/edited from Livestock (c)2008 by Scott Snowman (Recompense on Uldum(US))
-- Many thanks for helping accomplish this task!
--------------------------------------------------------------------------------------------------------------------------------
function Mounty_AddMountList(name, spellID)
	local returnName = name;
	local returnvalue = 1;
	local flying = false;
	local changes = false;
	local depend = false;
	local serpent = false;
	local seahorse = false;
--	GameTooltip_SetDefaultAnchor(MountyToolTip, UIParent)
	MountyToolTip:SetOwner(UIParent, "ANCHOR_NONE")
	MountyToolTip:SetHyperlink("spell:"..spellID) -- pull up the tooltip object we created and set it to the ID of the spell
	for i = 1, MountyToolTip:NumLines() do -- iterate over the number of lines in the tooltip
		local text = _G["MountyToolTipTextLeft"..i]:GetText() -- get the text from each line
		if(i == 1) then
			returnName = text;
		end
		for word in string.gmatch(text, "%S+") do -- look at each word in the line.  NOT %a+ because that apparently doesn't capture unicode characters, for the localized clients.
			if strfind(word, "flying") then
				flying = true
			end	
			if strfind(word, "depend") then
				depend = true
			end	
			if strfind(word, "changes") then
				changes = true
			end	
			if strfind(word, "Serpent") then
				serpent = true -- Cloud Serpent
			end	
			if strfind(word, MOUNTY_VASHJ_TEXT) then
				seahorse = true -- seahorse mounts also have the word "Vashj'ir" in them
			end
		end
	end -- parse the tooltip.  The variables outland, northrend, very, fast, location, and changes are set to true if the corresponding text is found
	MountyToolTip:Hide(); -- hide our dummy tooltip
	
	returnvalue = 1;
	if flying then -- Flying Mount 
		returnvalue = 2;
	end
	if depend then -- Riding/Flying Mount
		returnvalue = 3;
	end
	if changes then -- Riding/Flying Mount
		returnvalue = 3;
	end
	if serpent then -- Cloud Serpent
		returnvalue = 4;
	end
	if seahorse then -- Vashjir Only Swimming Mount 
		returnvalue = 5;
	end
	return returnvalue, returnName;
end

--------------------------------------------------------------------------------------------------------------------------------
-- Riding Skills
--------------------------------------------------------------------------------------------------------------------------------
function Mounty_GetRidingSkill()
	Mounty_ClearRidingSkill();
	local s, i, ii = 1, 1, MAX_SKILLLINE_TABS;
	local spell, spell1, spell2, spell3, spellsub = "", "", "", "", "";
	local isusable = nil;
	for i = 1, ii do
		local name, texture, offset, numSpells = GetSpellTabInfo(i, BOOKTYPE_SPELL);
		if name == "General" then
			for s = offset + 1, offset + numSpells do
				spell, spellsub = GetSpellBookItemName(s, BOOKTYPE_SPELL);
				isusable = IsUsableSpell(spell);
				if isusable then
					_,_,spell1, spell2 = string.find(spell, "(%S+) (%S+)");
					if spell == "Wisdom of the Four Winds" then
						Mounty_SetRidingSkill("Wisdom of the Four Winds");
					elseif spell == "Cloud Serpent Riding" then
						Mounty_SetRidingSkill("Cloud Serpent Riding");
					elseif spell == "Mount Up" then
						Mounty_SetRidingSkill("Mount Up");
					elseif spell == "Cold Weather Flying" then
						Mounty_SetRidingSkill("Cold Weather Flying");
					elseif spell == "Flight Master's License" then
						Mounty_SetRidingSkill("Flight Master's License");
					elseif spell2 == "Riding" then
						Mounty_SetRidingSkill(spell1);
					end
				end
			end
		end
	end
end

function Mounty_ClearRidingSkill()
	Ability.Ride = false;
	Ability.Fly = false;
	
	Ability.Location["Pandaria"] = false;
	Ability.Location["Northrend"] = false;
	Ability.Location["Outland"] = false;
	Ability.Location["Kalimdor"] = false;
	Ability.Location["Eastern"] = false;
	Ability.Location["Maelstrom"] = false;
	
	Ability.Skill["Apprentice"] = false;
	Ability.Skill["Journeyman"] = false;
	Ability.Skill["Expert"] = false;
	Ability.Skill["Artisan"] = false;
	Ability.Skill["Master"] = false;
	Ability.Skill["Journeyman"] = false;
	Ability.Skill["Cold"] = false;
	Ability.Skill["License"] = false;
	Ability.Skill["WFW"] = false;
	Ability.Skill["Serpent"] = false;
	Ability.Skill["MountUp"] = false;
end

function Mounty_SetRidingSkill(name)
	if name == "Wisdom of the Four Winds" then
		Ability.Skill.WFW = true;
		Ability.Location["Pandaria"] = true;
	elseif name == "Cloud Serpent Riding" then
		Ability.Skill["Serpent"] = true;
	elseif name == "Mount Up" then
		Ability.Skill["MountUp"] = true;
	elseif name == "Cold Weather Flying" then
		Ability.Skill["Cold"] = true;
		Ability.Location["Northrend"] = true;
	elseif name == "Flight Master's License" then
		Ability.Skill["License"] = true;
		Ability.Location["Kalimdor"] = true;
		Ability.Location["Eastern"] = true;
		Ability.Location["Maelstrom"] = true;
	elseif (name == "Expert") or (name == "Artisan") or (name == "Master") then
		Ability.Ride = true;
		Ability.Fly = true;
		Ability.Skill[name] = true;
		Ability.Location["Outland"] = true;
	elseif (name == "Apprentice") or (name == "Journeyman") then
		Ability.Skill[name] = true;
		Ability.Ride = true;
	end
end

--------------------------------------------------------------------------------------------------------------------------------
-- Print Functions
--------------------------------------------------------------------------------------------------------------------------------
function Mounty_Message()
	local spr,spf = 0,0;
	Mounty_WriteMacro();		
	DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff<Mounty> BEGIN Printout|r");
	if Mounty.Enabled then
		DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff<Mounty>|r  File: "..Mounty.FileNumber.."|cff00ffff by Drae|r");
		DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff<Mounty>|r  PlayerID: "..Mounty.ID);
	   	DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff<Mounty>|r|cff00ff00 Enabled|r");
		if Ability.Ride then
			DEFAULT_CHAT_FRAME:AddMessage("|cffffff00ABILITIES:");
--			DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff Current Riding Skill:|r");
			if Ability.Skill.Apprentice then
				spr,spf = 160,0;
				DEFAULT_CHAT_FRAME:AddMessage("|cff00ffffApprentice Riding|r (Riding "..spr.."% |cff00ffff- NO Flying|r)");
			elseif Ability.Skill.Journeyman then
				spr,spf = 200,0;
				DEFAULT_CHAT_FRAME:AddMessage("|cff00ffffJourneyman Riding|r (Riding "..spr.."% |cff00ffff- NO Flying|r)");
			elseif Ability.Skill.Expert then
				spr,spf = 200, 250;
				DEFAULT_CHAT_FRAME:AddMessage("|cff00ffffExpert Riding|r (Riding "..spr.."% - Flying "..spf.."%).");
			elseif Ability.Skill.Artisan then
				spr,spf = 200, 380;
				DEFAULT_CHAT_FRAME:AddMessage("|cff00ffffArtisan Riding|r (Riding "..spr.."% - Flying "..spf.."%).");
			elseif Ability.Skill.Master then
				spr,spf = 200, 410;
				DEFAULT_CHAT_FRAME:AddMessage("|cff00ffffMaster Riding|r (Riding "..spr.."% - Flying "..spf.."%).");
			else
				DEFAULT_CHAT_FRAME:AddMessage("|cffff0000"..Mounty.Player.." cannot Ride or Fly.");
			end
			if Ability.Skill.MountUp then
				spr = spr * 1.1;
				spf = spf * 1.1;
				DEFAULT_CHAT_FRAME:AddMessage("|cff00ffffDoes have guild perk Mount Up.|r (Speed x 1.1)");
			else
				DEFAULT_CHAT_FRAME:AddMessage("|cffff0000Does NOT have guild perk Mount Up (Speed x 1.1)|r");
			end
			DEFAULT_CHAT_FRAME:AddMessage(Mounty.Player.." Rides at "..spr.."%");
			if spf == 0 then
				DEFAULT_CHAT_FRAME:AddMessage(Mounty.Player.."|r|cff00ffff Cannot Fly|r");
			else
				DEFAULT_CHAT_FRAME:AddMessage(Mounty.Player.." Flies at "..spf.."%");
			end
			DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff------------------------------|r");
			if not Ability.Skill.Master then
				DEFAULT_CHAT_FRAME:AddMessage("|cffff0000"..Mounty.Player.." does NOT have Master Riding (Flying 410%).|r");
			end
			if Ability.Skill.License then
				DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff"..Mounty.Player.." has a Flight Master's License.|r");
			else
				DEFAULT_CHAT_FRAME:AddMessage("|cffff0000"..Mounty.Player.." does NOT have a Flight Master's License.|r");
			end
			if Ability.Skill.Cold then
				DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff"..Mounty.Player.." has Cold Weather Flying.|r");
			else
				DEFAULT_CHAT_FRAME:AddMessage("|cffff0000"..Mounty.Player.." does NOT have Cold Weather Flying.|r");
			end
			if Ability.Skill.WFW then
				DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff"..Mounty.Player.." has Wisdom of the Four Winds.|r");
			else
				DEFAULT_CHAT_FRAME:AddMessage("|cffff0000"..Mounty.Player.." does NOT have Wisdom of the Four Winds.|r");
			end
			if Ability.Skill.Serpent then
				DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff"..Mounty.Player.." has Cloud Serpent Riding.|r");
			else
				DEFAULT_CHAT_FRAME:AddMessage("|cffff0000"..Mounty.Player.." does NOT have Cloud Serpent Riding.|r");
			end
			DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff------------------------------|r");
			if Ability.Ride and (Ability.Mount.name.ride ~= "None Set") then
				DEFAULT_CHAT_FRAME:AddMessage(Mounty.Player.." may ride ground mounts on all continents.");
			else
				DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff<Mounty>|r|cffff0000 "..Mounty.Player.." may not ride.");
			end
			if Ability.Fly and (Ability.Mount.name.fly  ~= "None Set") then
				DEFAULT_CHAT_FRAME:AddMessage("|cffffff00"..Mounty.Player.." may fly in:|r");
				if Ability.Location.Kalimdor then
					DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff  Kalimdor =|r|cff00ff00 Yes|r");
				else
					DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff  Kalimdor =|r|cffff0000 No|r");
				end
				if Ability.Location.Eastern then
					DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff  Eastern Kingdoms =|r|cff00ff00 Yes|r");
				else
					DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff  Eastern Kingdoms =|r|cffff0000 No|r");
				end
				if Ability.Location.Outland then
					DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff  Outland =|r|cff00ff00 Yes|r");
				else
					DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff  Outland =|r|cffff0000 No|r");
				end
				if Ability.Location.Northrend then
					DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff  Northrend =|r|cff00ff00 Yes|r");
				else
					DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff  Northrend =|r|cffff0000 No|r");
				end
				if Ability.Location.Maelstrom then
					DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff  The Maelstrom =|r|cff00ff00 Yes|r");
				else
					DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff  The Maelstrom =|r|cffff0000 No|r");
				end
				if Ability.Location.Pandaria then
					DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff  Pandaria =|r|cff00ff00 Yes|r");
				else
					DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff  Pandaria =|r|cffff0000 No|r");
				end
			else
				DEFAULT_CHAT_FRAME:AddMessage("|cffff0000"..Mounty.Player.." is NOT able to fly.|r");
			end
		else
			DEFAULT_CHAT_FRAME:AddMessage("|cffff0000  "..Mounty.Player.." cannot Ride or Fly.");
		end
		Mounty_PrintSettings();
		DEFAULT_CHAT_FRAME:AddMessage("|cffffff00 MENU:");
		DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff<Mounty>|r  File: "..Mounty.FileNumber.."|cff00ffff by Drae|r");
		DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff<Mounty> Menu options:|r (use /mty or /mounty)");
		DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff  /mty|r Rewrites the <Mounty Macro> and shows this printout.");
		DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff  /mty|r|cff00ff00 safe|r Toggles Safefly on/off (default on)");
		DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff  /mty|r|cff00ff00 gen|r Places the <Mounty Macro> in the General Tab (Default).");
		DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff  /mty|r|cff00ff00 char|r Places the <Mounty Macro> in the Character Specific Tab.");
		DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff  /mty|r|cff00ff00 ride|r Set currently |cffffff00ACTIVE|r mount to |cff00ffff<Riding Mount>|r.");
		DEFAULT_CHAT_FRAME:AddMessage(" Set the |cffffff00<Shift Riding Mount>|r, by holding down the |cffffff00\[Shift\]|r key when pressing |cffffff00\[Enter\]|r");
		DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff  /mty|r|cff00ff00 fly|r Set currently |cffffff00ACTIVE|r mount to |cff00ffff<Flying Mount>|r.");
		DEFAULT_CHAT_FRAME:AddMessage(" Set the |cffffff00<Shift Flying Mount>|r, by holding down the |cffffff00\[Shift\]|r key when pressing |cffffff00\[Enter\]|r");
	else
	   	DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff<Mounty>|r|cffff0000 Disabled|r");
	   	DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff<Mounty>|r| Type /mty enable (to enable Mounty)");
	end
	DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff<Mounty> END Printout|r");
end

function Mounty_PrintSettings(ding)
	if ding then
	 	PlaySoundFile(MOUNTY_ActionSound);
	end
	DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff------------------------------|r");
		DEFAULT_CHAT_FRAME:AddMessage("|cffffff00 SETTINGS:");
	if Mounty.SafeFly then
	   	DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff<Mounty SafeFly>|r is|cff00ff00 On|r");
	   	DEFAULT_CHAT_FRAME:AddMessage("(Right-Click or |cffffff00\[Alt\]|r-Click macro to dismount while flying.)");
	else
	   	DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff<Mounty SafeFly>|r is|cffff0000 Off|r");
	   	DEFAULT_CHAT_FRAME:AddMessage("(Click macro to dismount while flying.)");
	end
	if Mounty.perChar then
		DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff<Mounty Macro> is in the|r|cff00ff00 Character Specific Tab.|r");
	else
		DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff<Mounty Macro> is in the|r|cff00ff00 General Tab.|r");
	end
	DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff------------------------------|r");
	if Mounty.Ride.nomod.coord > 0 then
	   	DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff<Riding Mount> |r|cff00ff00"..Mounty.Ride.nomod.name.."|r");
	   	DEFAULT_CHAT_FRAME:AddMessage("|cffffff00<Shift Riding Mount> |r|cff00ff00"..Mounty.Ride.Shift.name.."|r");
	else
	   	DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff<Riding Mount> |r|cff00ff00"..Mounty.Player.." is unable to ride.|r");
	end
	if Mounty.Fly.nomod.coord > 0 then
	   	DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff<Flying Mount> |r|cff00ff00"..Mounty.Fly.nomod.name.."|r");
	   	DEFAULT_CHAT_FRAME:AddMessage("|cffffff00<Shift Flying Mount> |r|cff00ff00"..Mounty.Fly.Shift.name.."|r");
	else
	   	DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff<Flying Mount> |r|cff00ff00"..Mounty.Player.." is unable to fly.|r");
	end
	DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff------------------------------|r");
end

function Mounty_BadMessage(message, badmessage)
	PlaySoundFile(MOUNTY_ErrorSound);
	DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff-- <Mounty> --|r|cffff0000 Unable to understand command: |cffffff00"..message.."|r");
	if message == "set" then
		DEFAULT_CHAT_FRAME:AddMessage("|cff00ffffType -|r|cffffff00 /mty fly|r|cff00ffff   -to set a flying mount.|r");
		DEFAULT_CHAT_FRAME:AddMessage("|cff00ffffType -|r|cffffff00 /mty ride|r|cff00ffff -to set a riding mount.|r");
	end
end

function Mounty_Test()
	DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff-- <Mounty> --|r");
	for key, value in pairs(Ability.Mount.name) do
		DEFAULT_CHAT_FRAME:AddMessage("|cffffff00"..key.."|r = |cff00ffff"..value.."|r");
	end
	DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff-- <MOUNTY> --|r");
	for key, value in pairs(MOUNTY[Mounty.Faction]) do
		DEFAULT_CHAT_FRAME:AddMessage("|cffffff00"..key.."|r = |cff00ffff"..value.."|r");
	end
end

--[[
function Mounty_Test()
	local WintergraspTimer = 0;
	local ii = GetNumWorldPVPAreas();
	for i=1,ii do
		local pvpID, localizedName, isActive, canQueue, startTime, canEnter = GetWorldPVPAreaInfo(i)
		if isActive then
			WintergraspTimer = 0;
		else
			WintergraspTimer = startTime;
		end
		if localizedName == "Wintergrasp" then
			DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff<Mounty> PvP Zone("..i..") - "..pvpID.." = <"..localizedName.."> @ "..WintergraspTimer.."|r");
		end
	end
	return WintergraspTimer;
end
--]]

